public class SurfaceRectangleAvecStructureEnConsole {

////////////////////////////////////////////////////

/* Type agrege de stockage d'une position du plan */

  static class Position2D {
    double x = 0.0;
    double y = 0.0; };

/* Type agrege de stockage d'un rectangle du plan */

  static class Rectangle2D {
    Position2D p1 = new Position2D();
    Position2D p2 = new Position2D(); };

/* Calcul de la surface d'un rectangle            */

  static double surfaceRectangle(Rectangle2D r) {
    double surface;
    surface = Math.abs(r.p2.x-r.p1.x)*
              Math.abs(r.p2.y-r.p1.y);
    return surface;
  }

////////////////////////////////////////////////////

/* Saisie au clavier de deux coins opposes        */
/* d'un rectangle 2D                              */

  static Rectangle2D saisirRectangle2D() {
    Rectangle2D r = new Rectangle2D();
    Console.afficher("SVP, x1? ");
    r.p1.x = Console.saisirDouble();
    Console.afficher("SVP, y1? ");
    r.p1.y = Console.saisirDouble();
    Console.afficher("SVP, x2? ");
    r.p2.x = Console.saisirDouble();
    Console.afficher("SVP, y2? ");
    r.p2.y = Console.saisirDouble();
    return r ;
  }

/* Programme principal                            */

  public static void main(String [] args) {
    Console.setTitle("SurfaceRectangleAvecStructure");
    Rectangle2D r;
    double srf;
    Console.afficherln("SVP, positions de 2 coins opposes: ");
    r = saisirRectangle2D();
    srf = surfaceRectangle(r);
    Console.afficherln("La surface est ",srf);
  }
}